import { ViewModelInterface } from './asViewModel.interface';
import { FilterInterface } from './asFilter.interface';
import { OnInit, EventEmitter, OnChanges, SimpleChanges, TemplateRef, ElementRef, Renderer2 } from '@angular/core';
import { Observable } from 'rxjs';
import { Subject } from 'rxjs';
import { NgbTypeaheadConfig } from '@ng-bootstrap/ng-bootstrap';
import { NgModel, FormGroup, FormControl } from '@angular/forms';
import { AsConfigService } from './asConfig.service';
import { HttpClient } from '@angular/common/http';
import { MatAutocompleteSelectedEvent } from '@angular/material/autocomplete';
export declare enum OperatorsEnum {
    eq = "=",
    lt = "<",
    le = "\u2264",
    ne = "\u2260",
    gt = ">",
    ge = "\u2265",
    startsWith = "[...",
    endsWith = "...]",
    contains = "[...]",
}
export declare class AsComponent implements OnInit, OnChanges {
    element: ElementRef;
    typeahead: NgbTypeaheadConfig;
    private _renderer;
    protected _http: HttpClient;
    private _config;
    editNext: EventEmitter<any>;
    editPrev: EventEmitter<any>;
    onChangeViewModel: EventEmitter<any>;
    externalTemplate: TemplateRef<any>;
    searchboxInput: ElementRef;
    searchboxModel: NgModel;
    typeaheadController: any;
    openOnLoad: boolean;
    searchBoxControl: FormControl;
    private _form;
    private _template;
    private _validators;
    private _operators;
    template: Array<ViewModelInterface>;
    model: Object;
    form: FormGroup;
    validators: any;
    operators: any;
    private _model;
    viewModel: ViewModelInterface[];
    searchBox: any;
    searchboxInputClick$: Observable<any>;
    searchboxClick$: Observable<any>;
    focusInput$: Subject<any>;
    filtersControllers: any;
    focusIndex: any;
    afterViewInitFilters$: Subject<any>;
    searchBoxFunc: any;
    formatter: any;
    formGroupSameModel: {
        [key: string]: FormGroup;
    };
    filteredOptions: Observable<string[]>;
    constructor(element: ElementRef, typeahead: NgbTypeaheadConfig, _renderer: Renderer2, _http: HttpClient, _config: AsConfigService);
    filterSearchBox(): Array<any>;
    trackByFn(index: any, item: any): any;
    displayAutocompleteFn(obj?: any): string | undefined;
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    populateForm(): void;
    removeFormControls(): void;
    findTemplate(key: any, value: any): ViewModelInterface;
    keydown(e: any, currentViewModel?: any, options?: {
        id?: any;
        blackList?: any;
    }): void;
    addFilter(event: MatAutocompleteSelectedEvent): void;
    createViewFilter(singleTemplate: any, value?: any): ViewModelInterface;
    createViewFilterFromModel(model: any): void;
    addFilterController(uuid: any, controller: any): void;
    removeFilterController(uuid: any): void;
    nextFilterController(viewModel: any): FilterInterface | AsComponent;
    prevFilterController(viewModel: any): FilterInterface | AsComponent;
    prevFilterControllerFromSearchbox(viewModel: any): FilterInterface | AsComponent;
    getFilterController(viewModel: any): FilterInterface;
    removeViewModel(viewModel: ViewModelInterface): void;
    removeAll(): void;
    onFocus(prevNext: any): void;
}
